.186

CODE	SEGMENT
			ASSUME CS:CODE
ifndef MSDOS
			ORG 0000h
else
			ORG 0100h
endif

include	itf.inc
include	pc98.inc
include	dataseg.inc
include	keyboard.inc
include	process.mac
include	debug.mac

dipitem		struc
items		db	?
item_y		db	?
item_mask	db	?
item_shr	db	?
item_x		db	4 dup(?)
item_title	dw	?
item_info	dw	4 dup(?)
item_sw		dw	4 dup(?)
dipitem		ends


START:			jmp		short main
				dw		offset dipswflag


main:			cld
				mov		ax, DATASEG
				mov		ds, ax

ifdef DEBUG_INIT
				DEBUG_INIT
endif

				KEYINT_INIT

				xor		ax, ax
				mov		es, ax
				test	byte ptr es:[0531h], 80h
				je		short main2
				mov		byte ptr ds:[KEYSTAT], 3fh

main2:			call	SCREEN_CLEAR

				mov		ah, 24
key1cklp:		call	boot_keycheck
				sub		al, BOOT_WFLASH
				jae		short boot_ext
				call	WAITVSYNC1
				dec		ah
				jne		key1cklp

				call	BEEP_TEST

				mov		ah, 32
key2cklp:		call	boot_keycheck
				cmp		al, BOOT_MENU
				je		short boot_menu
				jb		short key2cklp2
				mov		al, 0
key2cklp2:		call	WAITVSYNC1
				dec		ah
				jne		key2cklp
				jmps	boot_normal

boot_menu:		jmp		dipsws


bootproc		dw	offset FLASH_WRITE
				dw	offset FLASH_CLEAR
				dw	offset RESET_ALLSW

boot_ext:		xor		dx, dx
				mov		ah, 0
				add		ax, ax
				mov		bx, ax
				call	cs:bootproc[bx]
				mov		al, 90
				call	WAITVSYNC
				jmp		REBOOT_PROCESS

firmproc		dw	offset CPUMODE_DISP
				dw	offset BIOS_REVISON
				dw	offset FIRMWARE_TEST

boot_normal:	push	ax
				in		al, 31h
				test	al, 10h
				CALLNZ	MEMSW_INIT

				mov		cl, 0e1h
				xor		dx, dx
				pop		ax

				add		ax, ax
				mov		bx, ax
				call	cs:firmproc[bx]

				call	MEMORY_TEST

				mov		ah, 90
				call	WAITVSYNC

				clc
				jmp		exitprocess

include resource.x86
include itfsub.x86
include textdisp.x86
include	keyboard.x86
include	np2.x86
include	dipsw.x86
include	memsw.x86
include	beep.x86
include	firmware.x86
include memchk.x86


initmsgs	db		0e1h
			dw		0004h, offset menu_title
			db		0e1h
			dw		011eh, offset dipsw_title
			db		0e1h
			dw		121bh, offset dipsw_msg
			db		0a1h
			dw		130fh, offset dip1_msg
			db		0a1h
			dw		1327h, offset dip2_msg
			db		0a1h
			dw		133fh, offset dip3_msg
			db		0a1h
			dw		1404h, offset off_msg
			db		0a1h
			dw		1504h, offset on_msg
			db		065h
			dw		160ah, offset dipnum_msg
			db		065h
			dw		1622h, offset dipnum_msg
			db		065h
			dw		163ah, offset dipnum_msg
			db		0c1h
			dw		1800h, offset keyctl_meg
			db		000h


dip1items	db	2, 3, 20h, 5, 1eh, 28h, 00h, 00h
			dw	offset sw13_t
			dw	offset sw13_i ,	offset sw13_i , 0, 0
			dw	offset sw13_s0,	offset sw13_s1, 0, 0

			db	2, 5, 10h, 4, 1eh, 30h, 00h, 00h
			dw	offset sw14_t
			dw	offset sw14_i0,	offset sw14_i1, 0, 0
			dw	offset sw14_s0,	offset sw14_s1, 0, 0

			db	4, 8, 0ch, 2, 1eh, 2ah, 36h, 44h
			dw	offset sw15_t
			dw	offset sw15_i0,	offset sw15_i1
			dw	offset sw15_i2,	offset sw15_i3
			dw	offset sw15_s0,	offset sw15_s1
			dw	offset sw15_s2,	offset sw15_s3

			db	2,10, 01h, 0, 1eh, 24h, 00h, 00h
			dw	offset sw18_t
			dw	offset sw18_i0,	offset sw18_i1, 0, 0
			dw	offset sw18_s0,	offset sw18_s1, 0, 0

			db	0,12, 00h, 0, 00h, 00h, 00h, 00h
			dw	offset end_t, offset end_i

dip2items	db	2, 3, 40h, 6, 1eh, 30h, 00h, 00h
			dw	offset sw22_t
			dw	offset sw22_i0,	offset sw22_i1, 0, 0
			dw	offset sw22_s0,	offset sw22_s1, 0, 0

			db	2, 5, 10h, 4, 1eh, 2ch, 00h, 00h
			dw	offset sw24_t
			dw	offset sw24_i0,	offset sw24_i1, 0, 0
			dw	offset sw24_s0,	offset sw24_s1, 0, 0

			db	2, 7, 08h, 3, 1eh, 28h, 00h, 00h
			dw	offset sw25_t
			dw	offset sw25_i0,	offset sw25_i1, 0, 0
			dw	offset sw25_s0,	offset sw25_s1, 0, 0

			db	2, 9, 04h, 2, 1eh, 28h, 00h, 00h
			dw	offset sw26_t
			dw	offset sw26_i0,	offset sw26_i1, 0, 0
			dw	offset sw26_s0,	offset sw26_s1, 0, 0

			db	2,11, 01h, 0, 1eh, 28h, 00h, 00h
			dw	offset sw28_t
			dw	offset sw28_i0,	offset sw28_i1, 0, 0
			dw	offset sw28_s0,	offset sw28_s1, 0, 0

			db	0,13, 00h, 0, 00h, 00h, 00h, 00h
			dw	offset end_t, offset end_i

dip3items	db	2, 3, 10h, 4, 1eh, 26h, 00h, 00h
			dw	offset sw34_t
			dw	offset sw34_i0,	offset sw34_i1, 0, 0
			dw	offset sw34_s0,	offset sw34_s1, 0, 0

			db	2, 5, 08h, 3, 1eh, 24h, 00h, 00h
			dw	offset sw35_t
			dw	offset sw35_i0,	offset sw35_i1, 0, 0
			dw	offset sw35_s0,	offset sw35_s1, 0, 0

			db	2, 7, 01h, 0, 1eh, 28h, 00h, 00h
			dw	offset sw38_t
			dw	offset sw38_i0,	offset sw38_i1, 0, 0
			dw	offset sw38_s0,	offset sw38_s1, 0, 0

			db	0, 9, 00h, 0, 00h, 00h, 00h, 00h
			dw	offset end_t, offset end_i

dipitems	dw	offset dip1items, dip2items, dip3items


; ---------------------------------------------------------------------------

putboxv:		push	di
				mov		es:[di+2000h], cl
				stosw
				or		bx, bx
				je		putboxr
				push	bx
putboxc_lp:		mov		es:[di+2000h], cl
				mov		word ptr es:[di], 0095h
				inc		di
				inc		di
				dec		bx
				jne		putboxc_lp
				pop		bx
putboxr:		inc		al
				mov		es:[di+2000h], cl
				stosw
				pop		di
				ret

puttextbox:		push	bx
				push	cx
				push	dx
				push	di
				call	calc_dx2di
				mov		ch, bh
				sub		ch, 2
				js		putbox_ed
				mov		bh, 0
				sub		bx, 2
				js		putbox_ed
				mov		ax, 09ch
				call	putboxv
				add		di, 160
				or		ch, ch
				je		putbox_bm
				push	bx
				inc		bx
				add		bx, bx
putboxh_lp:		mov		word ptr es:[di], 96h
				mov		es:[di+2000h], cl
				mov		word ptr es:[di+bx], 96h
				mov		es:[di+bx+2000h], cl
				add		di, 160
				dec		ch
				jne		putboxh_lp
				pop		bx
putbox_bm:		mov		ax, 09eh
				call	putboxv
putbox_ed:		pop		di
				pop		dx
				pop		cx
				pop		bx
				ret

putext2_sub2:	mov		cl, 2
putext2_lp1:	mov		byte ptr es:[bx+di], dl
				mov		byte ptr es:[di], bh
				inc		di
				inc		di
				loop	putext2_lp1
				ret
puttextbox2:	pusha
				mov		bx, 2000h
				mov		di, 19*160+8*2
				mov		dx, 0365h
puttextbox2_lp:	mov		cx, 20
				call	putext2_lp1
				add		di, 160-40
				call	putext2_sub2
				add		di, 8*4
				call	putext2_sub2
				add		di, 160-40
				call	putext2_sub2
				add		di, 8*4
				call	putext2_sub2
				add		di, 160-40
				mov		cx, 20
				call	putext2_lp1
				sub		di, 160*3-4*2
				dec		dh
				jne		puttextbox2_lp
				popa
				ret

boxclear:		push	bx
				mov		ax, 20h
				mov		bh, 0e1h
				mov		bl, ch
boxclearylp:	push	di
				push	cx
				mov		ch, 0
boxclearxlp:	mov		es:[di+2000h], bh
				stosw
				loop	boxclearxlp
				pop		cx
				pop		di
				add		di, 160
				dec		bl
				jne		boxclearylp
				pop		bx
				ret

disptextjis:	push	dx
				push	di
				call	TEXTOUT_CS
				pop		di
				pop		dx
				ret

initmsgput:		mov		si, offset initmsgs
initmsglp:		db		FIXCS
				lodsb
				cmp		al, 0
				je		initmsged
				mov		cl, al
				db		FIXCS
				lodsw
				mov		dx, ax
				db		FIXCS
				lodsw
				push	si
				mov		si, ax
				call	disptextjis
				pop		si
				jmp		short initmsglp
initmsged:		ret


setdips:		push	bx
				push	cx
				mov		dl, al
				mov		dh, 0
				mov		di, dx
				mov		ch, [di+DIPSW_1]
				mov		di, 160*20+20
				shl		dx, 4
				add		di, dx
				shl		dx, 1
				add		di, dx

				mov		cl, 80h
dirput_lp:		mov		bx, 0a1h
				test	ah, cl
				je		dipcured
				mov		bl, 0e5h
dipcured:		mov		dx, 2101h
				test	ch, cl
				je		diphited
				mov		dx, 2202h
				xchg	bl, bh
diphited:		mov		es:[di+0000h], dx
				mov		es:[di+2000h], bh
				mov		es:[di+2002h], bh
				xor		dx, 0303h
				mov		es:[di+00a0h], dx
				mov		es:[di+20a0h], bl
				mov		es:[di+20a2h], bl
				add		di, 4
				shr		cl, 1
				jne		dirput_lp
				pop		cx
				pop		bx
				ret


dipitemadrs:	mov		bx, dx
				and		bx, 3
				mov		si, bx
				add		si, bx
				mov		si, cs:dipitems[si]
				mov		al, type dipitem
				mul		dh
				add		si, ax
				ret

setdipitem:		push	bx
				push	dx
				push	si
				push	di
				call	dipitemadrs
				mov		cl, cs:[si].item_shr
				shl		ch, cl
				mov		cl, cs:[si].item_mask
				and		ch, cl
				not		cl
				and		[bx+DIPSW_1], cl
				or		[bx+DIPSW_1], ch
				jmp		short dispitemmov

dispdipitem:	push	bx
				push	dx
				push	si
				push	di
				call	dipitemadrs
				mov		ch, [bx+DIPSW_1]
				and		ch, cs:[si].item_mask
dispitemmov:	push	bx
				mov		cl, cs:[si].item_shr
				shr		ch, cl
				mov		cl, 0a1h
				test	dl, 080h
				je		putitems_pos
				mov		cl, 0e5h
putitems_pos:	mov		dl, 4
				mov		dh, cs:[si].item_y
				push	si
				mov		si, cs:[si].item_title
				call	disptextjis
				pop		si
				and		cl, not 4
				xor		bx, bx
putitems_lp:	cmp		bl, cs:[si].items
				jae		short putitems_info
				mov		dl, cs:[si+bx].item_x
				add		bl, bl
				push	si
				mov		si, cs:[si+bx].item_sw
				shr		bl, 1
				cmp		ch, bl
				jne		short nocurs
				or		cl, 4
nocurs:			call	disptextjis
				and		cl, not 4
				pop		si
				inc		bl
				jmp		short putitems_lp
putitems_info:	pop		bx
				cmp		cl, 0e1h
				jne		putitems_ed
				push	cx
				mov		di, 17*160
				mov		cx, 0150h
				call	boxclear
				pop		cx
				mov		ah, cs:[si].item_mask
				mov		al, bl
				call	setdips
				mov		bl, ch
				mov		dl, cs:[si+bx].item_x
				add		bl, bl
				mov		dx, 1100h
				mov		si, cs:[si+bx].item_info
				call	disptextjis
putitems_ed:	mov		cl, cs:[si].items
				pop		di
				pop		si
				pop		dx
				pop		bx
				ret

dippage_set:	push	dx
				mov		dh, dl
				and		dx, 0300h
				add		dx, 3103h
				mov		word ptr es:[160*1+2fh*2], dx
				mov		ax, 0h
				call	setdips
				mov		ax, 1h
				call	setdips
				mov		ax, 2h
				call	setdips
				mov		di, 2*160+2
				mov		cx, 0e4eh
				call	boxclear
				pop		dx
				push	dx
				and		dx, 7fh
itemdisplps:	call	dispdipitem
				inc		dh
				or		cl, cl
				jne		itemdisplps
				mov		bl, dh
				pop		dx
				cmp		dh, bl
				jb		short curitemputs
				mov		dh, bl
				dec		dh
curitemputs:	or		dl, 80h
				call	dispdipitem
				ret




dipsws:			mov		di, 3fe0h
dipswflag:		mov		al, es:[di]
				test	al, 10h
				jne		short dipswflag2
				mov		byte ptr ds:[DIPSW_1], 01bh
				mov		byte ptr ds:[DIPSW_2], 04bh
				mov		byte ptr ds:[DIPSW_3], 048h
				jmp		short dipswflaged
dipswflag2:		mov		byte ptr ds:[DIPSW_1], 01ah
				mov		byte ptr ds:[DIPSW_2], 070h
				mov		byte ptr ds:[DIPSW_3], 071h
dipswflaged:	call	GET_DIPSW
				mov		ax, 0a000h
				mov		es, ax
				mov		dx, 0100h
				mov		bx, 1050h
				mov		cl, 0e1h
				call	puttextbox
				mov		dx, 1200h
				mov		bx, 0650h
				mov		cl, 0a1h
				call	puttextbox
				call	puttextbox2

				call	initmsgput

				mov		dx, 0000h

				mov		byte ptr ds:[KEYBAK], 0ffh

mainlpstart:	call	dippage_set
mainlpsub:		mov		al, ds:[KEYSTAT]
				cmp		ds:[KEYBAK], al
				je		short mainlpsub
				mov		ds:[KEYBAK], al
				test	al, 80h
				jne		short mainlpsub

				cmp		al, 3ah
				jne		short down_chk
				and		dl, 7fh
				call	dispdipitem
				dec		dh
				js		short pageprev
				call	curitemputs
				jmp		short mainlpsub
pageprev:		dec		dl
				jns		short mainlpstart
				mov		dl, 2
				jmp		short mainlpstart

down_chk:		cmp		al, 3dh
				jne		short left_chk
				and		dl, 7fh
				call	dispdipitem
				inc		dh
				cmp		dh, bl
				jae		short pagenext
				call	curitemputs
				jmp		short mainlpsub
pagenext:		mov		dh, 0
				inc		dl
				cmp		dl, 3
				jb		short mainlpstart
				mov		dl, 0
				jmp		short mainlpstart
left_chk:		cmp		al, 3bh
				jne		right_chk
				dec		ch
				call	setdipitem
				jmp		short mainlpsub
right_chk:		cmp		al, 3ch
				jne		homeclr_chk
				inc		ch
				call	setdipitem
				jmp		short mainlpsub
homeclr_chk:	cmp		al, 03eh
				jne		ret_chk
				call	INIT_DIPSW
				jmp		short mainlpstart
ret_chk:		cmp		al, 01ch
				jne		short esc_chk
				mov		al, dh
				inc		al
				cmp		al, bl
				je		short dipmenu_end

esc_chk:		cmp		al, 00h
				je		short dipmenu_end
				jmp		mainlpsub

dipmenu_end:	call	SET_DIPSW

; ---------------------------------------------------------------------------

REBOOT_PROCESS:	stc

exitprocess:	cli
				pushf
ifdef DEBUG_TERM
				DEBUG_TERM
endif
				KEYINT_TERM
				call	SCREEN_CLEAR
				mov		di, int09off + 8000h
				mov		cx, (DATASEGEND - int09off) / 2
				xor		ax, ax
				rep stosw
				popf
				ITF_EXIT

CODE	ENDS
	END START

